--[[
					     --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

			     The Pandaren Monk sat next to the disheveled, exhausted Orc and enquired "Tell me of your travels".

				The battle-scarred Orc, with forearms resting on his knees, looked wearily forward and sighed.
				      "I've walked the desert of Tanaris in search of the magicial Noggenfogger elixir."
			"I've trecked the Tempest Keep in farthermost Outlands to obtain a mythical can of Whoop-Ass."
			       "And I've explored the highest reaches of Storm Peaks for the magnificent Vrykul Drinking Horn."
							  "But nothing, nothing prepared me for..."

      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


				     #######     ####           ####       #                     #######     #   #######
				   ##          ##    ##       ##    ##     #                    #       #    #   #      ##
				  #           #        #     #        #    #                   #         #   #   #        #
				 #           #          #   #          #   #                   #         #   #   #         #
				 #           #          #   #          #   #                   ###########   #   #         #
				 #           #          #   #          #   #                   #         #   #   #         #
				  #           #        #     #        #    #                   #         #   #   #        #
				   ##          ##    ##       ##    ##     #                   #         #   #   #      ##
				     #######     ####           ####       ###########         #         #   #   #######


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

							    Tarocalypse smiled wisely at the Orc.
					       "It was foretold in the winds of Kun-Lai Summit my dear friend."
		       "And before that in the depths of the Molten Core where", he paused to reflect, "you should never be 'too soon'."
			     "And alas the many brethren we lost in Karazhan, they were just not ready when the curtain went up."

						     "Bah, all they blew was hot air!" Grumbled Taraezor.
 
			     They both looked sideways and exchanged smiles, silently recalling battles they had fought long ago.

							      Taraezor was the first to speak.
			    "Tell me my good friend. It is clear that when I need help with cooling down I surely need Cool Aid."
								"But I need to know this..."
						      He leaned closer to the wise Pandaren and grinned.

							    "Are you drinking the Cool Aid too?"

					     --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--



	      ----o----(||)----o----												  v2.10 6th August 2015
		  by Chris Birch
		     --o--o--
		All Rights Reserved
	      ----o----(||)----o----



	     ----o----o----o----(||)----o----o----o----
	 YOU'LL BE ON THE COOL AID TOO WITH THESE FEATURES!
	     ----o----o----o----(||)----o----o----o----

		*) Auto hide when not aggroed, in an instance or able to attack a target
		*) Tiles are resizable from extremely small to extremely large
		*) Recharge abilities (not strictly cooldowns) included
		*) Special case abilities such as Ascendance included
		*) Can include bag and gear items and player buffs and debuffs
		*) Every tile has a tooltip
		*) Every Interface panel has extra help available as tooltips
		*) Tiles can be easily moved
		*) No fixed way to group tiles together. It is up to you!
		*) Tiles all have the "second hand" animation for Cool Downs
		*) Configurable numeric countdown display of remaining seconds
		*) Can lock the tiles to avoid accidentally moving them
		*) Can micro-manage how frequently the display updates
		*) Can force display out of combat
		*) Can hide tiles until they are off or almost off cooldown
		*) Better icon display for Mage Polymorphs than Blizzard defaults


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

	 About the Author: I work full-time and was once a mainframe applications/systems designer/analyst. I do not play WoW full-time and after so
	   many years I am over the gear grind and raid rage. In Cata LFR I was typically very near the top for dps. Pre-Mists I had an extensive
	     mount collection and my pet collection was also awesome. I was the Guild Master of Hordecore Epics @ Thaurissan, a levelling guild.
				   I reside in Sydney Australia and am available for freelance programming in any language.

				     In Warlords of Draenor I am playing a variety of classes on the Frostmourne server.

      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--



--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::   DATA DEFINITIONS    :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================]]

-- Globals
----------
CoolAid			= {}
ca_debug		= "0"
ca_spellbook		= {}
ca_currentSpec		= ""
ca_buffsPlayer, ca_debuffsPlayer = {}, {}
-- Global so that another AddOn can work with Cool Aid
ca_shown = 1

-- Localisation Optimisation
----------------------------
local GetAddOnMetadata = GetAddOnMetadata
local GetCVar = GetCVar
local GetItemCooldown = GetItemCooldown
local GetItemIcon = GetItemIcon
local GetSpecialization = GetSpecialization
local GetSpellBookItemInfo = GetSpellBookItemInfo
local GetSpellCooldown = GetSpellCooldown
local GetSpellCharges = GetSpellCharges
local GetSpellInfo = GetSpellInfo
local GetTalentInfo = GetTalentInfo
local GetFlyoutInfo = GetFlyoutInfo
local GetFlyoutSlotInfo = GetFlyoutSlotInfo
local HasPetSpells = HasPetSpells
local IsInInstance = IsInInstance
local IsPassiveSpell = IsPassiveSpell
local IsSpellInRange = IsSpellInRange
local IsSpellKnown = IsSpellKnown
local UnitBuff = UnitBuff
local UnitAffectingCombat = UnitAffectingCombat
local UnitCanAttack = UnitCanAttack
local UnitClass = UnitClass
local UnitDebuff = UnitDebuff
local UnitHealth = UnitHealth
local UnitName = UnitName
local UnitPVPName = UnitPVPName
local UnitRace = UnitRace

local ipairs = ipairs
local pairs = pairs
local tostring = tostring
local type = type

-- Colours
----------
local ca_colour_processCyan		= "\124cFF00B7EB"	-- CoolAid chat line prefix
local ca_colour_dodgerBlue		= "\124cFF1e90ff"	-- Highlight and warning messages
local ca_colour_lightCornflowerBlue	= "\124cFF93CCEA"	-- Plain text
local ca_colour_electricCyan		= "\124cFF00FFFF"	-- Error messages
local ca_colour_electricBlue		= "\124cFF7DF9FF"	-- Debug messages

-- Locals to this file
----------------------
local ca_mainFrame
local ca_isRunning = false
local ca_coolAidFrames = {}
local ca_maxCoolAidFrames = 84
local ca_recentRunEventAvg, ca_prevTimeSinceLast, ca_sumOfRunFrequencies, ca_timeSinceLastSalutation = 0, 0, 0, 0
local ca_hasGlyph, ca_hasTalent = {}, {}
local ca_pvpName, ca_englishClass, ca_englishRace, ca_tryGetNameAgain = "", "", "", false
local ca_psTimerRecalc, ca_PTU_times = false, 0
local ca_doubleCountdownWarningDone = false

local ca_lookupSpec = { ["Deathknight"] = { "Blood", "Frost", "Unholy"},		-- Checked
			["Druid"] = {"Balance", "Feral", "Guardian", "Restoration"},	-- Checked
			["Hunter"] = {"Beast Mastery", "Marksmanship", "Survival"},	-- Checked
			["Mage"] = {"Arcane", "Fire", "Frost"},				-- Checked
			["Monk"] = {"Brewmaster", "Mistweaver", "Windwalker"},		-- Checked
			["Paladin"] = {"Holy", "Protection", "Retribution"},		-- Checked
			["Priest"] = {"Discipline", "Holy", "Shadow"},			-- Checked
			["Rogue"] = {"Assassination", "Combat", "Subtlety"},		-- Checked
			["Shaman"] = {"Elemental", "Enhancement", "Restoration"},	-- Checked
			["Warlock"] = {"Affliction", "Demonology", "Destruction"},	-- Checked
			["Warrior"] = {"Arms", "Fury", "Protection"}}			-- Checked

--===================================================================================================================================================--
--||																		   ||--
--||						        --=<[:::   DISPLAY COOLDOWNS   :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function CooldownLeft(spellItemID)	-- In sync with We Don't Wipe

-- This function does NOT support 'enabled' spells such as Presence of Mind. Must first check for buffs on player in those cases
-- This makes sense as by definition the cool down is 'undefined' until the player actually uses up the stored spell.

-- Invoked twice for each queue member: once pre-queue in AddToQueue and then in DisplayQueue
-- The cooldown will never be less than the remaining GCD unless the spell ignores the GCD (which does happen)

	local start, duration, enabled
	if spellItemID > 0 then
		start, duration, enabled = GetSpellCooldown(spellItemID)
	else
		start, duration, enabled = GetItemCooldown(-spellItemID)
	end

	if enabled == 0 then				-- Zero for Delayed CD spells such as Presence of Mind
		return 0, 0, 0
	end

	local cdLeft = start + duration - GetTime()
	if cdLeft < 0 or not cdLeft then
		cdLeft = 0
	elseif cdLeft > 0 then
		cdLeft = caRound(cdLeft,3)
	end
	return cdLeft, start, duration
end

local runningItDown, prevCount, prevTime = false, 0, 0

local function DisplayExtraStuff()

	local spellTexture, vStr = "", ""
	local lowCD, lowStart, lowDuration, curCharges, maxCharges = 0, 0, 0, 0, 0

	for i,v in ipairs(CoolAidDB[ca_currentSpec].showCDs_1) do		-- This block in sync with We Don't Wipe

		ca_coolAidFrames[i].cooldownText:SetText("")
		ca_coolAidFrames[i].spellID = v
		if v > 0 then
			vStr = tostring(v)							
			if ca_spellbook[vStr] then
				spellTexture = ca_spellbook[vStr].icon
			else
				_,_,spellTexture = GetSpellInfo(v)
			end
		else
			spellTexture = GetItemIcon(-v)
		end
		ca_coolAidFrames[i].spellTexture:SetTexture(spellTexture)
		ca_coolAidFrames[i]:SetAlpha(1)

		lowCD, lowStart, lowDuration, curCharges, maxCharges = 0, 0, 0, 0, 0

	-- -- -- -- -- -- -- -- -- --

		-- Recharges can be gotten from Tooltips but as whole seconds - not precise enough

		if ca_englishClass == "Druid" then

			if v == 62606 then -- Druid Bear Form Savage Defence	- 2 max charges in WoD. Down from 3. 12s recharge up from 9s

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(62606)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end
			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Mage" then

			if ((v == 157980) or (v == 122)) and ca_hasTalent["15"] and ca_currentSpec == "Arcane" then	-- Supernova

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(157980) 		-- Supernova
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif (v == 36032) and (ca_currentSpec == "Arcane") then					-- Arcane Charges stacking debuff

				if ca_debuffsPlayer["36032"] then
					lowDuration = 15
					lowCD = ca_debuffsPlayer["36032"].expires
					lowStart = GetTime() + lowCD - 15
				end

			elseif ((v == 157981) or (v == 122)) and ca_hasTalent["15"] and ca_currentSpec == "Fire" then	-- Blast Wave

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(157981)			-- Blast Wave
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif ((v == 108853) or (v == 2136)) and ca_currentSpec == "Fire" then

				if UnitLevel('player') < 24 then
					lowCD, lowStart, lowDuration = CooldownLeft(2136)				-- Fire Blast
				else
					lowCD, lowStart, lowDuration = CooldownLeft(108853)				-- Inferno Blast
				end

			elseif ((v == 157997) or (v == 122)) and ca_hasTalent["15"] and ca_currentSpec == "Frost" then	-- Ice Nova

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(157997)			-- Ice Nova
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif ((v == 116011) or (v == 116014)) and ca_hasTalent["17"] then				-- Rune of Power and RoP buff

				-- Imperfect solution. Once player steps in and out, crossing between the two, then the
				-- timers, whilst always finishing correctly, reset their "start time" to right "now"
				-- causing a soon to expire RoP to appear to have a fast moving sweeping hand

				if ca_buffsPlayer["116014"] then
					local timeLeft1, timeLeft2 = 0, 0
					local _, _, startTime1, duration1 = GetTotemInfo(1)
					local _, _, startTime2, duration2 = GetTotemInfo(2)

					if startTime1 ~= 0 then timeLeft1 = startTime1 + duration1 - GetTime() end
					if startTime2 ~= 0 then timeLeft2 = startTime2 + duration2 - GetTime() end

					if timeLeft1 > 0 and timeLeft2 > 0 then
						if timeLeft1 < timeLeft2 then
							lowStart = startTime1
							lowDuration = duration1
							lowCD = timeLeft1
						else
							lowStart = startTime2
							lowDuration = duration2
							lowCD = timeLeft2
						end
					elseif timeLeft1 > 0 then
						lowStart = startTime1
						lowDuration = duration1
						lowCD = timeLeft1
					elseif timeLeft2 > 0 then
						lowStart = startTime2
						lowDuration = duration2
						lowCD = timeLeft2
					end
				end

			elseif ((v == 1463) or (v == 116267)) and ca_hasTalent["18"] then		-- Incanter's Flow (Spell & Buff)

				-- Blizzard does not provide timing information for this buff. Forced to setup our own stepper & timer
				-- Buff strength steps, every second, as follows: 1 - 2 - 3 - 4 - 5 - 5 - 4 - 3 - 2 - 1
				-- Imperfect. For targets killed very quickly, the timer is wrong BUT it does "self correct" on the next mob

				if ca_buffsPlayer["116267"] then

					-- This is the easy part: display the buff step level as a numeric overlay
					lowCD = ca_buffsPlayer["116267"].count

					if prevTime == 0 then

						prevTime = GetTime()
						prevCount = ca_buffsPlayer["116267"].count

					elseif prevCount ~= ca_buffsPlayer["116267"].count then

						if (( prevCount == 1 ) or ( prevCount == 0 )) and ( ca_buffsPlayer["116267"].count == 2 ) then

							prevTime = GetTime()

						end
						prevCount = ca_buffsPlayer["116267"].count
						runningItDown = false
						ca_coolAidFrames[i].cooldown:SetCooldown(0,0)

					elseif runningItDown then

						-- Empirical results say 29.1s is the mark
						lowStart = prevTime
						lowDuration = 29.1
						if ( prevTime + lowDuration - GetTime() ) <= 10 then
							lowCD = prevTime + lowDuration - GetTime()
						end

					elseif ( GetTime() - prevTime ) > ( 10 + CoolAidDB[ca_currentSpec].updateFrequency ) then

						runningItDown = true
					end

				else
					if prevTime > 0 then
						-- The problem I have is that occasionally the time is LESS than 29s. As low as 23s once.
						-- Could detect no discernable pattern short of keeping a record over time :(
						caDebug("Elapsed = "..caRound(GetTime() - prevTime,1).." from count = "..prevCount,"if")
					end
					prevCount, prevTime, runningItDown = 0, 0, false
				end

			else

				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Monk" then

			if (v == 109132) or (v == 115008) then -- Monk's Roll/Chi Torpedo. Up to 2 charges, each refreshes after 20 seconds
				-- Works with or without Celerity talent taken

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(109132)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 125195 then						-- Tigereye Brew. Level 56 for WW Monks

				if ca_buffsPlayer["125195"] then

					lowDuration = 120
					lowCD = ca_buffsPlayer["125195"].expires
					lowStart = GetTime() + lowCD - 120
				end

			elseif (v == 115399) or (v == 145640) then -- Chi Brew. Level 45 talent. 2 charges, 1m.

				if IsSpellKnown(115399) then
					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(115399)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end
				end

			elseif (v == 129914) or (v == 121817) then			-- Power Strikes. Level 45 talent. 15s hidden cycle

				if CoolAidDB[ca_currentSpec].psTimerStart then
					lowDuration = 15
					local interval  = math.fmod((GetTime() - CoolAidDB[ca_currentSpec].psTimerStart),15)
					lowStart = GetTime() - interval
					lowCD = 15 - interval
				end

			elseif v == 115151 then						-- Renewing Mist. Level 24, Mistweaver

				if IsSpellKnown(115151) then
					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(115151)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end
				end

			elseif v == 107428 then						-- Rising Sun Kick. Level 56 (Charged for Mistweavers)

				if IsSpellKnown(107428) then
					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(107428)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end
				end

			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Paladin" then

				-- Clemency. Level 60 talent, all specialisations. All Hands now have two recharges
				-- Prior to WoD my code worked. Then something broke. In WoD I don't have a high enough Paladin to test this.
				-- Having a stab at using the default GetSpellCharges rather than my old manual (and accurate even with all 4 Hands) way

			if v == 1044 and ca_hasTalent["12"] then -- Hand of Freedom. Level 52

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(1044)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 6940 and ca_hasTalent["12"] then -- Hand of Sacrifice. Level 80

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(6940)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 1038 and ca_hasTalent["12"] then -- Hand of Salvation. Level 66

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(1038)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 1022 and ca_hasTalent["12"] then -- Hand of Protection. Level 48

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(1022)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 114637 then						-- Bastion of Glory. Level 40 5x stacking buff for Prot Pallies

				if ca_buffsPlayer["114637"] then

					lowDuration = 20
					lowCD = ca_buffsPlayer["114637"].expires
					lowStart = GetTime() + lowCD - 20
				end

			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Priest" then

			if v == 121536 then -- Angelic Feather - level 30 talent. 3 charges, 10s recharge

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(121536)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end
			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Shaman" then

			if v == 77130 then -- Purify Spirit. Level 18. 1 charge, 8s timer. Glyphed has 2 charges and 12s recharge

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(77130)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			-- Sneak in a couple of quality of life texture changes for Shammies here. Showing the love...

			elseif v == 73899 and ca_buffsPlayer["114051"] then -- Enhancement Shaman Primal Strike with an active Ascendance

				lowDuration = 15
				lowCD = ca_buffsPlayer["114051"].expires
				lowStart = GetTime() + lowCD - 15
				ca_coolAidFrames[i].spellTexture:SetTexture(GetSpellTexture(115356)) -- Use the Wind Strike texture!

			elseif v == 421 and ca_buffsPlayer["114050"] then -- Elemental Shaman Chain Lightning with an active Ascendance

				lowDuration = 15
				lowCD = ca_buffsPlayer["114050"].expires
				lowStart = GetTime() + lowCD - 15
				ca_coolAidFrames[i].spellTexture:SetTexture(GetSpellTexture(114074)) -- Use the Lava Beam texture!

			elseif v == 53817 and ca_currentSpec == "Enhancement" then	-- Maelstrom Weapon stacking buff
				if ca_buffsPlayer["53817"] then

					lowDuration = 30
					lowCD = ca_buffsPlayer["53817"].expires
					lowStart = GetTime() + lowCD - 30
				end

			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Warlock" then

			-- Demonic Gateway might be a candidate for here

			if v == 105174 then -- Hand of Gul'Dan. Has 2 charges and a 15 second recharge countdown. Generates a GCD

				-- Unsure if Metamorphosis results in a new Spell ID. Couldn't find one in Wowhead. Suspect it stays as is

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(105174)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 17962 then -- Destruction Warlock's Conflagrate. 2 charges, 12s recharge. 
						-- Down to 9s with the WoD PvP 4P bonus. GCD triggered

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(17962)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif ca_hasTalent["16"] then -- Archimonde's Darkness - Dark Soul spells now have two charges

				if v == 113861 then -- Dark Soul: Knowledge (Demonology). Two charges now

					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(113861)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end

				elseif v == 113860 then -- Dark Soul: Misery (Affliction). Two charges now

					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(113860)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end

				elseif v == 113858 then -- Dark Soul: Instability (Destruction). Two charges now

					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(113858)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end

				else
					lowCD, lowStart, lowDuration = CooldownLeft(v)
				end

			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

		elseif ca_englishClass == "Warrior" then

			if v == 2565 then -- Protection Warrior's Shield Block. 2 charges. In WoD the timer is 12s, up from 9s

				curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(2565)
				if curCharges < maxCharges then
					lowCD = lowStart + lowDuration - GetTime()
				end

			elseif v == 100 then -- Charge. 2 charges if the Double Time talent taken. 20s recharge

				if ca_hasTalent["2"] then -- Double Time - a second charge for Charge
					curCharges, maxCharges, lowStart, lowDuration = GetSpellCharges(100)
					if curCharges < maxCharges then
						lowCD = lowStart + lowDuration - GetTime()
					end
				else
					lowCD, lowStart, lowDuration = CooldownLeft(v)
				end
			else
				lowCD, lowStart, lowDuration = CooldownLeft(v)
			end

--caPrint("cur=".. caRound(curCharges,2).." max="..caRound(maxCharges,2).." lowCD=".. caRound(lowCD,2).." S=".. caRound(lowStart,2).." cD=".. caRound(lowDuration,2))

		else

	-- -- -- -- -- -- -- -- -- --

			lowCD, lowStart, lowDuration = CooldownLeft(v)
		end

		if CoolAidDB[ca_currentSpec].showWhenCoolingDown == 0 then		-- We Don't Wipe does NOT have this option
			if lowCD > CoolAidDB[ca_currentSpec].cooldownCountdown then
				ca_coolAidFrames[i]:SetAlpha(0)
				ca_coolAidFrames[i].cooldown:SetCooldown(0,0)
				ca_coolAidFrames[i].cooldownText:SetText("")
				return
			end
		end

		if lowCD > 0 then	-- This block in sync with We Don't Wipe

			-- Patch 6.1 introduced Cooldown Timer bugs. Following code works for most (all?) of the bugs
			-- Might have occurred prior to 6.1 but certainly prevalent in 6.1. 6.0.2 added new timer API calls. Hmmm...
			-- Basically, after a 'reload ui' the server rejects any CD start being set prior to GetTime()
			-- And in certain situations cooldown:GetCooldownTimes() returns trashy data
			-- Thankfully WeDontWipe:CooldownLeft(v) always returns good data
			-- As well as '/reload ui' we also need to deal with full screen frame redraws and zone changes
			-- Additionally results depend also upon whether a CD persists after relogging (e.g. Evocation)

			local dodgyStart = ca_coolAidFrames[i].cooldown:GetCooldownTimes()
			dodgyStart = floor(dodgyStart/1000)

			if (dodgyStart == 0) and (ca_coolAidFrames[i].lowCD == 0) then

				-- true for '/reload ui', GCD, relogging and first time
				-- Will reflect GCD minus 100ths of seconds it took to get here. See 2nd (clean) below

				ca_coolAidFrames[i].cooldown:SetCooldown( GetTime(), lowCD)
				ca_coolAidFrames[i].cooldown:SetAlpha(0.9)
				ca_coolAidFrames[i].lowCD = lowCD

			elseif (dodgyStart > GetTime()) and (ca_coolAidFrames[i].lowCD ~= 0) then

				-- true for full screen Map AFTER a '/reload ui' or relogging with a persistent CD. Executed 2nd, after the test below

				ca_coolAidFrames[i].cooldown:SetCooldown( GetTime(), lowCD)
				ca_coolAidFrames[i].cooldown:SetAlpha(0.9)
				ca_coolAidFrames[i].lowCD = lowCD

			elseif lowCD > ca_coolAidFrames[i].lowCD then

				-- true for 2nd (clean) iteration and after full screen Map. This is regardless of '/reload ui' or relogging
				-- If here for the 2nd (clean) iteration then a "stutter" will occur due to the CD restarting

				ca_coolAidFrames[i].cooldown:SetCooldown( lowStart, lowDuration)	-- As it should be
				ca_coolAidFrames[i].cooldown:SetAlpha(0.9)
				ca_coolAidFrames[i].lowCD = lowCD

			elseif ( GetTime() - lowStart ) < 0.2 then

				ca_coolAidFrames[i].cooldown:SetCooldown( GetTime(), lowCD)
				ca_coolAidFrames[i].cooldown:SetAlpha(0.9)
				ca_coolAidFrames[i].lowCD = lowCD
			end

			-- Use this to make the edge of the swiper hand a frosty white instead of the default yellow
			--ca_coolAidFrames[i].cooldown:SetEdgeTexture("Interface\\Cooldown\\edge-LoC")
			-- Default is true. False is Blizzard's new way - no bright edge to the hand
			--ca_coolAidFrames[i].cooldown:SetDrawEdge(false)

			--ca_coolAidFrames[i].cooldown:SetCooldown( lowStart, lowDuration)
			if CoolAidDB[ca_currentSpec].cooldownCountdown >= lowCD then
				if lowCD > 2 then
					lowCD = caRound(lowCD,0)
					if lowCD > 120 then
						local min, sec = math.floor(lowCD/60), math.fmod(lowCD,60)
						lowCD = min.."m"..sec
					end
				else
					lowCD = caRound(lowCD,1)
				end
				ca_coolAidFrames[i].cooldownText:SetText(lowCD)
				ca_coolAidFrames[i].cooldownText:SetTextColor(1, 1, 1, 1)
			end

		elseif ca_coolAidFrames[i].lowCD ~= 0 then

			-- This is necessary to avoid CD text remaining at "0.1"

			ca_coolAidFrames[i].cooldownText:SetText("")
			ca_coolAidFrames[i].lowCD = 0
		end
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

local function SalutationName() -- Synced with We Don't Wipe

	-- Need to filter out slowness from server side in providing the PvP Name (i.e. name + title). Cannot assume English
	ca_tryGetNameAgain = false
	ca_pvpName = UnitPVPName("player")
	if string.find( ca_pvpName, UNKNOWNOBJECT, 1, true) then
		-- Possibly have the 'Unknown' name returned from the server. Unlikely that 'Unknown' appears in the title, in any language
		-- All we can really do is try again later
		ca_tryGetNameAgain = true
		ca_pvpName = UnitName("player")
		if ca_pvpName == UNKNOWNOBJECT then ca_pvpName = "" end
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::       MAIN LOOP       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function LetsGetItOn()

	-- A simple wipe(table) or table = {} would be easier except that memory usage (due to uncollected garbage) climbs about 6K per second
	-- and this might alarm some users, who suspect a memory leak. The convolutions below lessen the usage escalation to 1-5K per new buff
	-- BuffPlayer and DebuffPlayer in sync with We Don't Wipe

	local name, count, buffType, expires, spellID
	for k,v in pairs(ca_buffsPlayer) do
		v.ignore = 1
	end
	for i=1,40 do
		name, _, _, count, buffType, _, expires, _, _, _, spellID = UnitBuff("player", i)
		if not name then break end
		if expires ~= 0 then expires = expires - GetTime() end
		if (buffType == "" or buffType == nil) then buffType = "N/A" end
		if ca_buffsPlayer[tostring(spellID)] then
			ca_buffsPlayer[tostring(spellID)].ignore = 0
			ca_buffsPlayer[tostring(spellID)].count = count
			ca_buffsPlayer[tostring(spellID)].expires = expires
			ca_buffsPlayer[tostring(spellID)].type = buffType
		else
			ca_buffsPlayer[tostring(spellID)] = {["count"] = count, ["expires"] = expires, ["name"] = name, ["type"] = buffType}
		end
	end
	for k,v in pairs(ca_buffsPlayer) do
		if v.ignore == 1 then ca_buffsPlayer[k] = nil end
	end
	for k,v in pairs(ca_debuffsPlayer) do
		v.ignore = 1
	end
	for i=1,40 do
		name, _, _, count, buffType, _, expires, _, _, _, spellID = UnitDebuff("player", i)
		if not name then break end
		if expires ~= 0 then expires = expires - GetTime() end
		if (buffType == "" or buffType == nil) then buffType = "N/A" end
		if ca_debuffsPlayer[tostring(spellID)] then
			ca_debuffsPlayer[tostring(spellID)].ignore = 0
			ca_debuffsPlayer[tostring(spellID)].count = count
			ca_debuffsPlayer[tostring(spellID)].expires = expires
			ca_debuffsPlayer[tostring(spellID)].type = buffType
		else
			ca_debuffsPlayer[tostring(spellID)] = {["count"] = count, ["expires"] = expires, ["name"] = name, ["type"] = buffType}
		end
	end
	for k,v in pairs(ca_debuffsPlayer) do
		if v.ignore == 1 then ca_debuffsPlayer[k] = nil end
	end

	-- -- -- -- -- -- -- -- -- --

	if CoolAidDB[ca_currentSpec].showCooldowns == 1 and CoolAidDB[ca_currentSpec].cooldownCountdown > 0 then
		if GetCVar("countdownForCooldowns") == "1" then
			if not ca_doubleCountdownWarningDone then
				caError("You have setup CA to show a Cooldown 'Countdown' but you also enabled this option in the WoW Interface "..
					"'Actionbars' Panel. The CA version is more powerful. It is suggested you disable the WoW Interface "..
					"version.\nPresently, with both enabled, TWO sets of numbers will be overlayed upon your cooldowns.")
				ca_doubleCountdownWarningDone = true
			end
		else
			ca_doubleCountdownWarningDone = false
		end
	else
		ca_doubleCountdownWarningDone = false
	end

	-- -- -- -- -- -- -- -- -- --

	if CoolAidDB[ca_currentSpec].showCooldowns == 0 then return end

	local healthTarget = 0
	if UnitName("target") then
		healthTarget = UnitHealth("target")
	end
	local _,instanceType = IsInInstance()

	if UnitHealth("player") > 1 and
		( (UnitCanAttack("player","target") and healthTarget > 0) or UnitAffectingCombat("player") or
			(instanceType == "party" or instanceType == "raid") ) or CoolAidDB[ca_currentSpec].showOutsideCombat == 1 then

		DisplayExtraStuff()
		if #CoolAidDB[ca_currentSpec].showCDs_1 < ca_maxCoolAidFrames then
			for i=#CoolAidDB[ca_currentSpec].showCDs_1+1,ca_maxCoolAidFrames do
				ca_coolAidFrames[i]:SetAlpha(0)
				ca_coolAidFrames[i].cooldown:SetCooldown(0,0)
				ca_coolAidFrames[i].cooldownText:SetText("")
				ca_coolAidFrames[i].lowCD = 0
			end
		end
	else
		savedStart, prevCount = 0, 0
		for i=1,ca_maxCoolAidFrames do
			ca_coolAidFrames[i]:SetAlpha(0)
			ca_coolAidFrames[i].cooldown:SetCooldown(0,0)
			ca_coolAidFrames[i].cooldownText:SetText("")
			ca_coolAidFrames[i].lowCD = 0
		end
		if GetTime() - ca_timeSinceLastSalutation > 3600 then
			ca_timeSinceLastSalutation = GetTime()
			SalutationName()
			if not ca_tryGetNameAgain or ca_pvpName ~= "" then
				caPrint("Hey "..ca_colour_dodgerBlue..ca_pvpName..ca_colour_lightCornflowerBlue.."! Are you on the Cool Aid?")
				if not WeDontWipe then PlaySoundFile("Sound/Spells/Fairytale_Sfx_01.Ogg") end -- Non intrusive, pleasant sparkling sound
			end
		end
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[::: ADJUNCT FUNCTIONS FOR :::]>=--							   ||--
--||							--=<[:::    EVENT HANDLERS     :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local function InitialiseFrame(f)		-- In sync with We Don't Wipe
	f:SetFrameStrata("BACKGROUND")
	f:EnableMouse(false)
	f:SetEnabled(false)
	f:SetMovable(false)
	f:ClearAllPoints()

	f.spellTexture = f:CreateTexture(nil,"BACKGROUND")
	f.spellTexture:SetAllPoints(f)

	f.cooldown = CreateFrame("Cooldown", nil, f, "SecureActionButtonTemplate CooldownFrameTemplate")
	f.cooldown:SetAllPoints(f)
	f.cooldownText = f:CreateFontString(nil, "OVERLAY")
	f.cooldownText:SetFont("Fonts\\FRIZQT__.TTF", 42, "OUTLINE")
	f.cooldownText:SetAllPoints()

	f.spellID = 0
	f.shown = 0
	return f
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

function CoolAid:ResolveSpecFillSpellbook()

	-- Reminder: This routine is invoked before display frame elements have been setup

	local spec = GetSpecialization()

	if spec then
		ca_currentSpec = ca_lookupSpec[ca_englishClass][spec]
	else
		ca_currentSpec = "Unknown"
	end

	-- -- -- -- -- -- -- -- -- --
	-- Risk of nil class and such but without this then invalid players not able to get a look at the interface options
	CoolAid:DataDefaultsSetup()

	if tostring(ca_debug) == "0" then
		ca_debug = CoolAidDB[ca_currentSpec].debug
	end
	if tostring(ca_debug) ~= "0" then
		caDebug("Debug mode is: "..ca_colour_dodgerBlue..ca_debug,ca_debug)
	end

	-- -- -- -- -- -- -- -- -- --

	-- API for talents changed in WoD. I must work within this paradigm but then need to convert back to old style indexing

	local activeSpec = GetActiveSpecGroup() -- WoD style. 1 = primary, 2 = secondary
	wipe(ca_hasTalent)

	for i=1,7 do
		for j=1,3 do
--			local talentID, name, texture, selected, available = GetTalentInfo(i, j, activeSpec, false, false)
			local _, _, _, selected = GetTalentInfo(i, j, activeSpec, false, false)
			if selected then
				ca_hasTalent[tostring(((i-1)*3)+j)] = 1
			else
				ca_hasTalent[tostring(((i-1)*3)+j)] = nil
			end
		end
	end

	wipe(ca_hasGlyph)
	for i=1, NUM_GLYPH_SLOTS do
		local _, _, _, glyphSpellID = GetGlyphSocketInfo(i)
		if glyphSpellID then
			ca_hasGlyph[tostring(glyphSpellID)] = 1
		end
	end

	-- -- -- -- -- -- -- -- -- --

	-- Blizzard insists on a Spellbook INDEX being passed to IsSpellInRange(). We setup a table of these here. We still need to handle Flyouts and
	-- spells which are not in the usual out-of-combat Spellbook (i.e. Stormblast) and pets which come and go (E.g. Water Elemental)
	-- To here on a zone change. Spellbook data might not be available. This routine seems to get called five times on a zone change
	-- In sync with We Don't Wipe AddOn

	wipe(ca_spellbook)
	local _,_,offset,numEntries = GetSpellTabInfo(2)
	local icon, numSlots, isKnown = "", 0, false

	for i=1,offset+numEntries do
		local skillType, spellID = GetSpellBookItemInfo(i,"spell")
		if skillType == "SPELL" then
			-- For all unknown spells, they have the type "FUTURESPELL"
			if IsPassiveSpell(i,"spell") then
				if spellID == 20608 then -- Reincarnation
					_, _, icon = GetSpellInfo(spellID)
					ca_spellbook[tostring(spellID)] = {["index"] = i, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
				end
			elseif spellID == 6603 then -- Auto Attack
				-- Don't add to Spellbook
			elseif spellID == 118 then -- Mage Polymorph
				if ca_hasGlyph["56375"] then -- Glyph of Polymorph
					icon = "Interface/Icons/Ability_Mage_ImprovedPolymorph" -- Blizzard have the icon but... doesn't use it
				else
					_, _, icon = GetSpellInfo(spellID) -- Plain old sheep. Forgive the Mage, he knows not what he does
				end
				ca_spellbook[tostring(spellID)] = {["index"] = i, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
			elseif spellID == 31687 then -- Mage's Summon Water Elemental
				if ca_hasGlyph["146976"] then -- Glyph of Unbound Elemental
					icon = "Interface/Icons/Spell_Frost_SummonWaterElemental" -- Blizzard have the icon but... doesn't use it
				else
					_, _, icon = GetSpellInfo(spellID) -- Plain old Water Elemental
				end
				ca_spellbook[tostring(spellID)] = {["index"] = i, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
			else
				_, _, icon = GetSpellInfo(spellID)
				ca_spellbook[tostring(spellID)] = {["index"] = i, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
			end
		elseif skillType == "FLYOUT" then
			_, _, numSlots, isKnown = GetFlyoutInfo(spellID)
			if isKnown and numSlots > 0 then
				for j=1,numSlots do
					local flyID, overrideSpellID, isKnown = GetFlyoutSlotInfo(spellID,j)
					if isKnown then
						local _, _, icon = GetSpellInfo(flyID)
						ca_spellbook[tostring(flyID)] = {["index"] = 0, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
					end
				end
			end
		end
	end

	-- -- -- -- -- -- -- -- -- --

	-- Setup for a Frost Mage's Elemental. On casting/dismissing/dieing/targeting/mounting/dismounting Blizzard events comes to here more than
	-- once, and each time the spellbook index can vary. IsSpellInRange doesn't work for pets anyway so save index as a zero
	-- For a Frost Mage, the HasPetUI() API call does NOT work
	-- In sync with We Don't Wipe AddOn

	local numPetSpells = HasPetSpells() or 0
	if numPetSpells > 0 then
		for i=1,numPetSpells do
			local skillType, spellID = GetSpellBookItemInfo(i,BOOKTYPE_PET)
			if skillType == "SPELL" and not IsPassiveSpell(i,BOOKTYPE_PET) then
				local _, _, icon = GetSpellInfo(spellID)
				ca_spellbook[tostring(spellID)] = {["index"] = 0, ["book"] = BOOKTYPE_SPELL, ["icon"] = icon}
			end
		end
	end

	-- -- -- -- -- -- -- -- -- --

	if ca_englishClass == "Monk" then
		if IsSpellKnown(121817) then								-- Power Strikes
			local found = false
			for i=1,40 do
				_, _, _, _, _, _, _, _, _, _, spellID = UnitBuff("player", i)
				if not spellID then break end
				if spellID == 129914 then
					found = true 
					break
				end
			end
			if not found then
				if not CoolAidDB[ca_currentSpec].psTimerStart or (ca_PTU_times > 1 and not ca_isRunning) then
					local i,f = math.modf(GetTime())
					if f > 0.5 then
						i = i + f - 0.5
					end
					CoolAidDB[ca_currentSpec].psTimerStart = i
				end
			end
		elseif CoolAidDB[ca_currentSpec].psTimerStart then
			CoolAidDB[ca_currentSpec].psTimerStart = nil
		end	
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::  REGISTER AND HANDLE  :::]>=--							   ||--
--||							--=<[:::        EVENTS         :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

local eventFrame, CoolAidEvents = CreateFrame("Frame"), {}
local ca_lastUnitPetTime = 0

function CoolAidEvents:UNIT_PET(...)	-- Note: Cool Aid throttles this but WDW doesn't

-- Get multiple of these every time the pet goes away or returns. 1.5 second throttling gets most of the repeat calls but not all. Mileage would
-- vary for players depending upon latency and if in a capital city etc

	if ca_isRunning then
		if ((ca_lastUnitPetTime + 1.5) < GetTime()) then CoolAid:ResolveSpecFillSpellbook() end			
		ca_lastUnitPetTime = GetTime()
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

function CoolAidEvents:PLAYER_TALENT_UPDATE(...)	-- Triggersx5 before EVENT_PlayerEnteringWorld, hence the need for 'ca_isRunning' local
							-- In sync with We Don't Wipe

	ca_PTU_times = ca_PTU_times + 1			-- 5x for login, 1x for Talent update, 1x for Reload UI

	if ca_isRunning then
		CoolAid:ResolveSpecFillSpellbook()
		CoolAid:InitialiseInterface()
		CoolAid:RepositionFrames()		-- Necessary? Cool Aid has it but WDW didn't
	end
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

function CoolAidEvents:PLAYER_ENTERING_WORLD(...)

	ca_timeSinceLastSalutation = GetTime()

	_, ca_englishClass = UnitClass("player")
	ca_englishClass = string.sub(ca_englishClass,1,1)..string.lower(string.sub(ca_englishClass,2))
	_, ca_englishRace = UnitRace("player")

	ca_debug = ca_debug or "0"
	if tostring(ca_debug) ~= "0" then
		caDebug("Debug mode will be forced to: "..ca_colour_dodgerBlue..ca_debug,ca_debug)
	end

	-- -- -- -- -- -- -- -- -- --

	CoolAid:ResolveSpecFillSpellbook()

	if ca_mainFrame then return end

	-- Below this line for the definite first time in. Everything that needs to be setup on talent/zone/whatever changes must be done above.
	-- Cool Aid is not able to use a traditional login event due to (1) having shared routines (2) positioning (3) reloads of spells/talents

	SalutationName()
	if not ca_tryGetNameAgain or ca_pvpName ~= "" then
		caPrint(ca_salutation[ca_englishRace]..ca_colour_dodgerBlue..ca_pvpName..ca_colour_lightCornflowerBlue..
			"! Have you been drinking Cool Aid v"..GetAddOnMetadata("CoolAid","Version").."?")
	end
	if not WeDontWipe then PlaySoundFile(ca_salutation_Sound[ca_englishRace]) end

	-- -- -- -- -- -- -- -- -- --

	-- create the main frame and configure it
	ca_mainFrame = CreateFrame("Frame","CoolAidMain",UIParent,"SecureActionButtonTemplate")
	ca_mainFrame:SetFrameStrata("BACKGROUND")
	ca_mainFrame:SetClampedToScreen(true)		-- don't allow to be dragged off screen
	ca_mainFrame:EnableMouse(false)
	ca_mainFrame:SetMovable(true)

	ca_mainFrame:ClearAllPoints()
	ca_mainFrame:SetPoint( CoolAidDB[ca_currentSpec].tileRelP, CoolAidDB[ca_currentSpec].tilePosX, CoolAidDB[ca_currentSpec].tilePosY)

	-- add scripts for repositioning
	ca_mainFrame:SetScript("OnMouseDown", function(self, button)
		if (CoolAidDB[ca_currentSpec].positionLocked == 0) and button == "LeftButton" 
				and ca_mainFrame:IsShown() then
			if ca_coolAidFrames[1]:GetAlpha() == 1 then
				self:StartMoving()
			end
		end
	end)
	ca_mainFrame:SetScript("OnMouseUp", function(self)
		self:StopMovingOrSizing()
		local _, _, relativePoint, xOfs, yOfs = ca_mainFrame:GetPoint()
		CoolAidDB[ca_currentSpec].tilePosX = xOfs
		CoolAidDB[ca_currentSpec].tilePosY = yOfs
		CoolAidDB[ca_currentSpec].tileRelP = relativePoint
	end)
	ca_mainFrame:SetScript("OnEnter", function(self)
		if (CoolAidDB[ca_currentSpec].positionLocked == 0) and ca_coolAidFrames[1]:IsShown() then
			if ca_coolAidFrames[1]:GetAlpha() == 1 then
				caPrint("You may now move Cool Aid!")
				PlaySoundFile("Sound/Interface/Mapping.Ogg")
			end
		end
	end)

	for i=1,ca_maxCoolAidFrames do
		local parentFrame = ca_mainFrame
		local f = CreateFrame("Button","CoolAidButton" .. i, nil)
		ca_coolAidFrames[i] = InitialiseFrame(f)
	end

	CoolAid:RepositionFrames()
	CoolAid:InitialiseInterface()

	if ca_tryGetNameAgain then
		ca_pvpName = UnitPVPName("player")
	end

	ca_isRunning = true

	ca_mainFrame:SetScript('OnUpdate', function(self, timeSinceLast)

-- It is here that Blizzard invokes our add-on on a cyclical basis. For the author, 0.05s to 0.07s at very worst is the frequency to here.
-- This is easily good enough for this add-on to work and thus trying to bypass any perceived 'infrequency' by hooking into events is pointless.
-- If there is a gain to be made (debatable) then the gain would be negligible. LOL. (Almost all dps add-ons use events)

-- ca_recentRunEventAvg is the fairly accurate average of how often WoW is able to bring us here. It is pointless for the user to set a value for 
-- CoolAidDB[ca_currentSpec].updateFrequency lower than this. A higher value for updateFrequency might be useful in overcoming lag.
-- No access to DB fields in here

		if ca_recentRunEventAvg == 0 then
			ca_recentRunEventAvg = caRound(timeSinceLast,3)
		else
			local fractionalDiff = timeSinceLast / ca_prevTimeSinceLast
			fractionalDiff = fractionalDiff * fractionalDiff
			if fractionalDiff < 1 then
				fractionalDiff = 1 / fractionalDiff
			end
			ca_recentRunEventAvg = (ca_recentRunEventAvg * fractionalDiff + timeSinceLast) / (fractionalDiff + 1)
			ca_recentRunEventAvg = caRound(ca_recentRunEventAvg,3)
		end
		ca_prevTimeSinceLast = timeSinceLast

-- This is where we self-throttle based upon player request

		ca_sumOfRunFrequencies = ca_sumOfRunFrequencies + timeSinceLast
		if ca_sumOfRunFrequencies > CoolAidDB[ca_currentSpec].updateFrequency then
			ca_sumOfRunFrequencies = 0
			LetsGetItOn()
		end
	end)
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

eventFrame:SetScript("OnEvent", function(self, event, ...)		-- In sync with We Don't Wipe
	CoolAidEvents[event](self, ...)
end)

for k,v in pairs(CoolAidEvents) do
	eventFrame:RegisterEvent(k)
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::   REPOSITION FRAMES   :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

function CoolAid:RepositionFrames()

	local size = CoolAidDB[ca_currentSpec].tileSize

	if not UnitAffectingCombat("player") then
		ca_mainFrame:ClearAllPoints()
		ca_mainFrame:SetPoint( CoolAidDB[ca_currentSpec].tileRelP, CoolAidDB[ca_currentSpec].tilePosX, CoolAidDB[ca_currentSpec].tilePosY)
		ca_mainFrame:SetSize(size,size)
		ca_mainFrame:SetHitRectInsets(size/3,size/3,size/3,size/3)

		for i,f in ipairs(ca_coolAidFrames) do
			f:SetAlpha(0)
			f:SetSize(size,size)
			f:ClearAllPoints()
			if i == 1 then
				f:SetPoint("CENTER", ca_mainFrame, "CENTER")
			elseif CoolAidDB[ca_currentSpec].horizontal == 1 then -- vertical alignment
				if math.floor((i-1)/CoolAidDB[ca_currentSpec].vertical) == (i-1)/CoolAidDB[ca_currentSpec].vertical then
					if CoolAidDB[ca_currentSpec].indentation ~= 0 then
						f:SetPoint("LEFT", ca_coolAidFrames[i-CoolAidDB[ca_currentSpec].vertical], "RIGHT", 0, 
							- 	CoolAidDB[ca_currentSpec].indentation * size)
					else
						f:SetPoint("LEFT", ca_coolAidFrames[i-CoolAidDB[ca_currentSpec].vertical], "RIGHT", 0, 0)
					end
				else
					f:SetPoint("TOP", ca_coolAidFrames[i-1], "BOTTOM", 0, 0)
				end
			else
				if math.floor((i-1)/CoolAidDB[ca_currentSpec].horizontal) == (i-1)/CoolAidDB[ca_currentSpec].horizontal then
					if CoolAidDB[ca_currentSpec].indentation ~= 0 then
						f:SetPoint("TOP", ca_coolAidFrames[i-CoolAidDB[ca_currentSpec].horizontal], "BOTTOM",
							CoolAidDB[ca_currentSpec].indentation * size, 0)
					else
						f:SetPoint("TOP", ca_coolAidFrames[i-CoolAidDB[ca_currentSpec].horizontal], "BOTTOM", 0, 0)
					end
				else
					f:SetPoint("LEFT", ca_coolAidFrames[i-1], "RIGHT", 0, 0)
				end
			end

			f.spellTexture:SetAllPoints(f)
			f.cooldownText:SetTextHeight(CoolAidDB[ca_currentSpec].tileSize/2)
			f.cooldownText:SetAllPoints()
		end
	end

	-- -- -- -- -- -- -- -- -- --
	
	ca_shown = CoolAidDB[ca_currentSpec].showCooldowns
	if ca_shown == 1 then
		if not UnitAffectingCombat("player") then ca_mainFrame:Show() end
	else
		return
	end

	-- -- -- -- -- -- -- -- -- --
	
	if caRound(CoolAidDB[ca_currentSpec].updateFrequency,2) == 0.00 then
		CoolAidDB[ca_currentSpec].updateFrequency = ca_recentRunEventAvg
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::    SLASH COMMANDS     :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

SLASH_CoolAid1, SLASH_CoolAid2, SLASH_CoolAid3, SLASH_CoolAid4 = "/coolaid", "/cool", "/ca", "/aid"

SlashCmdList["CoolAid"] = function(options)

	local secondParm, options3
	for v in string.gmatch(options, "(%S+)") do
		v = string.lower(v)
		if not options3 then
			options3 = string.sub(v,1,3)
		else
			secondParm = string.sub(v,1,3)
			break
		end
	end

	if options3 == "coo" then
		InterfaceOptionsFrame_OpenToCategory(ca_Interface)
		InterfaceOptionsFrame_OpenToCategory(ca_cooldownsFrame)
	elseif options3 == "opt" then
		InterfaceOptionsFrame_OpenToCategory(ca_Interface)
		InterfaceOptionsFrame_OpenToCategory(ca_optionsFrame)
	elseif options3 == "abo" then
		InterfaceOptionsFrame_OpenToCategory(ca_Interface)
		InterfaceOptionsFrame_OpenToCategory(ca_aboutFrame)
	elseif options3 == "tro" then
		InterfaceOptionsFrame_OpenToCategory(ca_Interface)
		InterfaceOptionsFrame_OpenToCategory(ca_troubleFrame)
	elseif options3 == "hel" or options3 == "?" then
		caPrint("Chat Commands:\n"..
			ca_colour_dodgerBlue.."opt / coo / hel / tro / abo\124r = show the 'Options',\n"..
				"    'Cooldown', 'Help', 'Troubleshooting', 'About' Panels\n\n"..
			ca_colour_dodgerBlue.."sho / hid / off\124r  = show, hide or turn off CA\n"..
			ca_colour_dodgerBlue.."rel\124r  = reload ALL AddOns\n"..
			ca_colour_dodgerBlue.."deb\124r  = 'Debug Mode' help & settings\n"..
			ca_colour_dodgerBlue.."fre\124r  = show how often CA is cycled\n"..
			ca_colour_dodgerBlue.."ver\124r  = show version number\n")
		InterfaceOptionsFrame_OpenToCategory(ca_Interface)
		InterfaceOptionsFrame_OpenToCategory(ca_helpFrame)
	elseif options3 == "deb" then
		if secondParm == "?" or not secondParm then
			caPrint("Debug mode is: "..ca_colour_dodgerBlue..tostring(ca_debug).."\124r\n"..
				"Possible values:\n"..
				"    "..ca_colour_dodgerBlue.."-1\124r = show all debug messages\n"..
				"    "..ca_colour_dodgerBlue.."0\124r  = no debug messages\n"..
				"    "..ca_colour_dodgerBlue.."n\124r  = where 'n' is a number. Limit belonging to group 'n'\n"..
				"    "..ca_colour_dodgerBlue.."x\124r  = where 'x' is a string. Limit belonging to group 'x'\n"..
				ca_colour_lightCornflowerBlue.."(Usage: '/ca deb n' in chat)")
		else
			ca_debug = secondParm
			CoolAidDB[ca_currentSpec].debug = tostring(secondParm)
			caPrint("Debug mode set to: "..ca_colour_dodgerBlue..tostring(secondParm))
		end
	elseif options3 == "fre" or options3 == "upd" then
		caPrint("Update frequency = "..tostring(ca_recentRunEventAvg))
	elseif options3 == "gar" then
		collectgarbage()
	elseif options == "hid" then
		for i=1,ca_maxCoolAidFrames do ca_coolAidFrames[i]:Hide() end
		ca_mainFrame:Hide()
		CoolAidDB[ca_currentSpec].showCooldowns = 0
		ca_shown = 0
	elseif options == "sho" then
		ca_mainFrame:Show()
		CoolAidDB[ca_currentSpec].showCooldowns = 1
		ca_shown = 1
	elseif options == "off" or options3 == "sto" then
		Slash("hid")
		ca_isRunning = false
		ca_mainFrame:SetScript('OnUpdate', nil)
	elseif options == "on" or options == "run" then
		caPrint("'/ca rel' is required to restart again. This reloads ALL AddOns")
	elseif options3 == "rel" then
		ReloadUI()
	elseif options3 == "ver" then
		local version = GetAddOnMetadata("CoolAid","Version")
		caPrint(ca_colour_dodgerBlue.."Version\124r = "..version)
	elseif options3 == "sal" then
		PlaySoundFile(ca_salutation_Sound[ca_englishRace])
	elseif options3 == "gcd" then
		local _,duration = GetSpellCooldown(61304) -- thankyou Blizzard for this spell!
		if duration > 0 then
			caPrint(ca_colour_dodgerBlue.."GCD\124r = "..duration)
		else
			caPrint(ca_colour_dodgerBlue.."GCD\124r = no GCD at present")
		end
	elseif options3 == "sef" or options == "poth" then
		PlaySoundFile("Sound\\Music\\ZoneMusic\\DMF_L70ETC01.mp3")
	end
end

--===================================================================================================================================================--
--||																		   ||--
--||							--=<[:::      MISCELLANY       :::]>=--							   ||--
--||																		   ||--
--===================================================================================================================================================--

function caRound(num, decimalPlaces)			-- In sync with We Don't Wipe AddOn
	local mult = 10^(decimalPlaces or 0)
	local rounder = 0.5
	if num < 0 then rounder = -rounder end
	return math.modf(num * mult + rounder) / mult
end

-------------------------------------------------------------------------------------------------------------------------------------------------------

function caDebug(s,group)			-- In sync with We Don't Wipe AddOn
	local cmon = false
	if ca_debug == "-1" then
		cmon = true
	else
		group = string.sub(tostring(group),1,3)
		if group == ca_debug then
			cmon = true
		end
	end
	if cmon then
		DEFAULT_CHAT_FRAME:AddMessage(ca_colour_processCyan.."CoolAid: "..ca_colour_electricBlue.. tostring(s).."\124r")
	end
end

function caError(s)
	DEFAULT_CHAT_FRAME:AddMessage(ca_colour_processCyan.."CoolAid: "..ca_colour_electricCyan..tostring(s).."\124r")
end

function caPrint(s)
	DEFAULT_CHAT_FRAME:AddMessage(ca_colour_processCyan.."CoolAid: "..ca_colour_lightCornflowerBlue..tostring(s).."\124r")
end

function caWarning(s)
	DEFAULT_CHAT_FRAME:AddMessage(ca_colour_processCyan.."CoolAid: "..ca_colour_dodgerBlue..tostring(s).."\124r")
end